# Generated by Django 3.1.3 on 2020-12-30 23:49

from django.db import migrations, models

def gen_anual_plan_from_booking_year(apps, schema_editor):
    AnualPlan = apps.get_model('core', 'AnualPlan')
    ReceivedInvoice = apps.get_model('core', 'ReceivedInvoice')
    IssuedInvoice = apps.get_model('core', 'IssuedInvoice')
    Request = apps.get_model('core', 'Request')
    InternalBooking = apps.get_model('core', 'InternalBooking')

    for received in ReceivedInvoice.objects.all():
        received.anual_plan = AnualPlan.objects.filter(year=received.booking_year)[0]
        received.save()

    for issued in IssuedInvoice.objects.all():
        issued.anual_plan = AnualPlan.objects.filter(year=issued.booking_year)[0]
        issued.save()

    for request in Request.objects.all():
        request.anual_plan = AnualPlan.objects.filter(year=request.booking_year)[0]
        request.save()

    for request in InternalBooking.objects.all():
        request.anual_plan = AnualPlan.objects.filter(year=request.booking_year)[0]
        request.save()


class Migration(migrations.Migration):

    dependencies = [
        ('core', '0081_auto_20210102_0012'),
    ]

    operations = [
        migrations.RenameField(
            model_name='receivedinvoice',
            old_name='internal_invoice_number',
            new_name='internal_booking_number',
        ),
        migrations.RenameField(
            model_name='issuedinvoice',
            old_name='internal_invoice_number',
            new_name='internal_booking_number',
        ),
        migrations.RenameField(
            model_name='internalbooking',
            old_name='receiver',
            new_name='requester',
        ),
        migrations.AddField(
            model_name='receivedinvoice',
            name='anual_plan',
            field=models.ForeignKey(null=True, on_delete=models.deletion.PROTECT, to='core.anualplan', verbose_name='Haushaltsplan'),
        ),
        migrations.AddField(
            model_name='issuedinvoice',
            name='anual_plan',
            field=models.ForeignKey(null=True, on_delete=models.deletion.PROTECT, to='core.anualplan', verbose_name='Haushaltsplan'),
        ),
        migrations.AddField(
            model_name='request',
            name='anual_plan',
            field=models.ForeignKey(null=True, on_delete=models.deletion.PROTECT, to='core.anualplan', verbose_name='Haushaltsplan'),
        ),
        migrations.AddField(
            model_name='internalbooking',
            name='anual_plan',
            field=models.ForeignKey(null=True, on_delete=models.deletion.PROTECT, to='core.anualplan', verbose_name='Haushaltsplan'),
        ),
        migrations.RunPython(gen_anual_plan_from_booking_year),
    ]
